.cseg
; ********************************************************************************************
; alle Interrupt-Routinen					[s,  cyc]
; ********************************************************************************************


; ---------------------------------------------------------------------------------------------
; 50s System-Timer:							[3,28 s, 105 cyc]
; ---------------------------------------------------------------------------------------------

TCC0_OVF_v:	pushsr				;; <temp> und Statusregister retten
		push	ZL
		push	ZH

; ---------------------------------------------
; Sinus-Sample ausgeben:

TIM0DAC:	clr	temp			;; lower DAC-Byte
		lds	temp,sinusout
		sts	DACB_CH0DATA,temp	;; ...setzen
		lds	temp,sinusout+1		;; higher DAC-Byte
		sts	(DACB_CH0DATA+1),temp	;; ...setzen
		sei				; Interrupts frei geben
;
		ldsw	Z,sinusrp		; lade nchstes
		lpm	temp,Z+			; ...DAC-Sample (L)
		sts	sinusout,temp		; ...vorab
		lpm	temp,Z+			; ...und DAC-Sample (H)
		sts	sinusout+1,temp
		cpiw	Z,(2*SINTAB12)+40	; Tabellenende erreicht?
		brne	dacout_ende		; nein...
		ldiw	Z,(2*SINTAB12)		; Zeiger auf Anfang
DACOUT_ENDE:	stsw	sinusrp,Z		; neuen Zeiger speichern

; ----------------------------------------------
; System-Timer:

TIM0SYS:	decram	timer_10ms		; 10ms abgelaufen?
		brne	tcc0_end		; nein...
		ldi	temp,200		; 10ms-Intwervall
		sts	timer_10ms,temp		; ...neu starten
		rcall	timer10			; alle Timer abarbeiten
		sbi	flags1,TIM10MS		; 10ms-Timerablauf merken

; ---------------------------------------------

TCC0_END:	pop	ZH
		pop	ZL
		popsr
		reti



; ---------------------------------------------------------------------------------------------
; ADCA_CH0-Ready:					[0,94/1,59 s, 30/51 cyc] alle 125s
; ---------------------------------------------------------------------------------------------

ADCA_INT:	pushsr
		push	ZL
		push	ZH
		sei				; Interrupt frei geben

; ---------------------------------------------
; ADCA einlesen und in Buffer speichern:

		ldsw	Z,captbufp		; Zeiger in den Input-Buffer
		lds	temp,ADCA_CH0RES	; (L)-Ergebnis
		st	Z+,temp			; ...im Buffer speichern
		lds	temp,(ADCA_CH0RES+1)	; (H)-Ergebnis
		st	Z+,temp			; ...im Buffer speichern
		stsw	captbufp,Z		; neuen Bufferzeiger retten	
		decram	captcnt			; Einlesevorgang zhlen, Buffer voll?
		brne	adc_ch0end		; nein...

; ----------------------------------------------
; Markiere neuen ADC-Buffer, wechsle Buffer

		sbic	flags1,CAPTBUFWR	; wurde jetzt CAPTBUF1 gefllt?
		rjmp	switch2buf0		; ja...
SETADCBUF1:	ldiw	Z,CAPTBUF1		; ADC vwerwendet
		stsw	captbufp,Z		; ...jetzt CPTBUF1
		sbi	flags1,CAPTBUFWR	; Umschaltung auf CPTBUF1 merken
		rjmp	setadcstart
;
SWITCH2BUF0:	ldiw	Z,CAPTBUF0		; ADC verwendet 
		stsw	captbufp,Z		; ...jetzt CPTBUF0
		cbi	flags1,CAPTBUFWR	; Umschaltung auf CPTBUF0 merken
;
SETADCSTART:	ldi	temp,128		; Abtastung im nchsten
		sts	captcnt,temp		; ...positiven Nulldurchgang des
		sbi	flags1,ADCBUFRDY	; Berechnung starten

; ---------------------------------------------
ADC_CH0END:	pop	ZH
		pop	ZL
		popsr
		reti
