.cseg
; ********************************************************************************************
; Unterprogramme:
; ********************************************************************************************


; -----------------------------------------------------------------------------------------------
; Grafikbox mit Beschriftung und Teilung aufbauen:			[1563,78 s,  50041 cyc]
; -----------------------------------------------------------------------------------------------
		
GRAFIK:		ldi	temp,14			; X-Position der Grafik
		sts	grafik_xstart,temp	; ...vom linken Displayrand
		ldi	temp,9			; Y-Position der Grafik
		sts	grafik_ystart,temp	; ...vom oben Displayrand
		ldi	temp,63			; X-Ausdehnung der Grafik
		sts	grafik_breite,temp	; ...vom X-Ursprung nach rechts
		ldi	temp,48			; Y-Ausdehnung der Grafik
		sts	grafik_hoehe,temp	; ...vom Y-Ursprung nach unten

; ----------------------------------------------
; Grafikumrahmung:

		lds	temp,grafik_xstart	; X-Start
		sts	dispx,temp		; ...setzen
		lds	temp,grafik_ystart	; Y-Start
		sts	dispy,temp		; ...setzen
		lds	temp,grafik_breite	; Breite
		sts	dispbreite,temp		; ...setzen
		lds	temp,grafik_hoehe	; Hhe
		sts	disphoehe,temp		; ...setzen
		ldi	temp,0b11111111		; volle Linie
		sts	dispmuster,temp		; ...setzen
		rcall	disp_rahmen		; ueren Rahmen schreiben

; ----------------------------------------------
; Y-Achsenstriche:

		ldi	temp,0b11111111		; volle Linie
		sts	dispmuster,temp		; ...setzen
		ldi	temp,2			; Breite fr
		sts	dispbreite,temp		; ...Achsenstriche
		lds	temp,grafik_xstart	; X-Start
		dec	temp			; ...erzeugen
		sts	dispx,temp		; ...und setzen
		ldi	counter,4		; Anzahl der Linien
		ldi	buffer,10		; relative Y-Anfangskoordinate
GRAF_LOOP1:	lds	temp,grafik_ystart	; relative Koordinate
		add	temp,buffer		; ...in absolute Koordinate
		sts	dispy,temp		; ...umrechen
		rcall	disp_hline		; Trennline schreiben
		ldi	temp,10			; 10dB Offset
		add	buffer,temp		; ...verwenden
		dec	counter			; alle Linien fertig?
		brne	graf_loop1		; nein...

; ----------------------------------------------
; Y-Beschriftung:

		rcall	disp_font1		; kleinen Font setzen
		lds	temp,grafik_xstart	; X-Start
		subi	temp,8			; ...fr 2-Dezimalstellen
		sts	dispx,temp		; ...setzen
		ldi	counter,5		; Anzahl der Zahlenwerte
		clr	akku0			; Anfangswert: 0dB
		lds	temp,grafik_ystart	; relative Y-Koordinate
		subi	temp,2			; ...in absolute Y-Koordinate
		sts	dispy,temp		; ...umrechnen
GRAF_LOOP2:	lds	temp,grafik_xstart	; relative X-Koordinate
		ldi	buffer,-14		; ...in absolute
		add	temp,buffer		; ...X-Koordinate
		sts	dispx,temp		; ...umreechnen
		rcall	disp_dez2r		; Zahlenwert rechtsbndig ausgeben
		ldi	temp,10			; -10dB Schritte
		sub	akku0,temp		; ...verwenden
		lds	buffer,dispy		; nchste absolute
		add	buffer,temp		; ...Y-Koordinate
		sts	dispy,buffer		; ...einstellen
		dec	counter			; alle dB-Werte ausgegeben?
		brne	graf_loop2		; nein...

; ----------------------------------------------
; X-Achsenstriche:

		lds	temp,grafik_xstart	; X-Start
		addi	temp,15			; ...auf 1kHz
		sts	dispx,temp		; ...setzen
		lds	temp,grafik_ystart	; Y-Start
		lds	buffer,disphoehe	; unteres Ende
		add	temp,buffer		; ...erzeugen
		sts	dispy,temp		; ...setzen
		ldi	counter,4		; Anzahl der Markierungspunkte
		ldi	temp,16			; Offset fr die Marken
		mov	akku0,temp		; ...einstellen
		lds	akku1,dispx		; erste X-Startpunkt
GRAF_LOOP3:	rcall	disp_dot		; Punkt setzen
		add	akku1,akku0		; nchste X-Koordinate
		sts	dispx,akku1		; ...einstellen
		dec	counter			; X-Markierung fertig?
		brne	graf_loop3		; nein...

; ----------------------------------------------
; X-Beschriftung:

		lds	temp,grafik_xstart	; X-Start
		addi	temp,12			; ...auf 1kHz
		sts	dispx,temp		; ...setzen
		lds	temp,grafik_ystart	; Y-Start
		lds	buffer,disphoehe	; unteres Ende
		add	temp,buffer		; ...erzeugen
		addi	temp,2			; 2 Pixelzeilen Abstand
		sts	dispy,temp		; Y-Start setzen
		ldi	counter,4		; Anzahl der Markierungspunkte
GRAF_LOOP4:	ldi	temp,5			; erzeuge
		sub	temp,counter		; ...kHz-Wert
		push	temp			; Wert retten
		rcall	disp_nibble		; ...ausgeben
		pop	temp			; ...und restaurieren
		tst	temp			; erster angezeigter Wert?
		brne	graf_xkilo		; nein...
		lds	temp,dispx		; wegen 0-Ausrichtung
		addi	temp,3			; ...X nur um 3
		sts	dispx,temp		; ...erhhen
		rjmp	graf_4next

GRAF_XKILO:	ldi	temp,'k'		; kHz-Silbe
GRAF_XWERT:	rcall	disp_out		; ...anhngen
GRAF_4NEXT:	lds	temp,dispx
		addi	temp,8			; X-Koordinate
		sts	dispx,temp		; ...verschieben
		dec	counter			; Ausgabe beendet?
		brne	graf_loop4		; nein...

; ----------------------------------------------
; Beschriftung:

		lds	temp,grafik_xstart
		subi	temp,13
		sts	dispx,temp
		lds	temp,grafik_ystart
		subi	temp,8
		sts	dispy,temp
;
		ldi	counter,-1		; ohne Begrenzung
		ldiw	Z,(2*DBVTXT)		; "dBV"
		rcall	disp_printrom		; ...ausgeben
		lds	temp,grafik_xstart
		addi	temp,10
		sts	dispx,temp
		ldiw	Z,(2*NFSPEK)		; "NF-Spektrum"
		rcall	disp_printrom		; ...ausgeben
	
; ----------------------------------------------
; 8 Bit Werte linear anzeigen (125Hz..3,9kHz):

		lds	akku0,grafik_xstart	; X-Start
		lds	akku1,grafik_ystart	; Y-Start der Grafik
		lds	akku2,grafik_hoehe	; Hhe (relatives unteres Ende) der Grafik
		mov	akku3,akku1		; Berechne den absoluten Y-Endpunkt
		add	akku3,akku2		; ...jeder V-Linie
;
		ldi	counter,(FFT_N/2)-1 	; Gleichspannungswert abtrennen!
		ldiw	Y,(DISPBUF+1)		; Zeiger in den Ausgabevektor
		clr	const			; 0-Ergnzung
GRAF_LOOP5:	ld	temp,Y+			; hole ein Ergebnis-Byte
		ldiw	Z,(2*DB20TAB)		; dBV-Lookup-Tabelle		
		add	ZL,temp			; Zeiger in Lookup-Tabelle
		adc	ZH,const		; ...mit linearem Ergebnis erzeugen
		lpm	temp,Z			; ...und zugehrigen dBV-Wert holen
		sts	dispx,akku0		; X-Startpunkt setzen
		mov	buffer,akku1		; Maximum der Grafik (oben)
		add	buffer,temp
		sts	dispy,buffer		; Y-Startpunkt setzen
		mov	buffer,akku2
		sub	buffer,temp
		sts	disphoehe,buffer	; Y-Hhe setzen
		rcall	disp_vline		; ...und zeichnen
		inc	akku0			; nchste X-Position
		dec	counter			; Vektor ausgegeben?
		brne	graf_loop5		; nein...
		
; ----------------------------------------------
; horizontale Teillinien im 10dB-Abstand:

		lds	temp,grafik_xstart
		sts	dispx,temp
		lds	temp,grafik_breite
		sts	dispbreite,temp
		ldi	temp,0b10101010		; 10dB-Linienmuster
		sts	dispmuster,temp		; ...setzen
		ldi	temp,$ff
		sts	dispeor,temp
		ldi	counter,4		; Anzahl der Linien
		ldi	buffer,10		; relative Y-Anfangskoordinate
GRAF_LOOP6:	lds	temp,grafik_ystart	; relative Koordinate
		add	temp,buffer		; ...in absolute Koordinate
		sts	dispy,temp		; ...umrechen
		rcall	disp_hline		; Trennline schreiben
		ldi	temp,10			; 10dB Offset
		add	buffer,temp		; ...verwenden
		dec	counter			; alle Linien fertig?
		brne	graf_loop6		; nein...
		
; ----------------------------------------------
; Filterfunktion anzeigen:

		rcall	disp_font1		; verwende kleinen Font
		ldi	temp,87
		sts	dispx,temp
		ldi	temp,59
		sts	dispy,temp
		ldi	counter,10		; Begrenze Ausgabe
		ldsw	Z,filtertxtp		; lade mit DG_TASTE ausgewhlten Filtertext
		rcall	disp_printrom		; ...und zeige ihn an

; ----------------------------------------------
; Copyright ausgeben:

		rcall	disp_font1		; Grundeinstellung
		ldi	temp,107
		sts	dispx,temp
		ldi	temp,0
		sts	dispy,temp
		ldi	counter,-1		; ohne Begrenzung
		ldiw	Z,(2*COPYRIGHT)		; "DC7GB"
		rcall	disp_printrom		; ...anzeigen

; ----------------------------------------------
GRAF_END:	ret



; -----------------------------------------------------------------------------------------------
; SINAD-Messwert eintragen:						[ 236,06 s,   7554 cyc]
; -----------------------------------------------------------------------------------------------
		
MESSWERT:	rcall	disp_font1		; kleinen Font verwenden
;
		lds	temp,timer_lowinp	; Eingangspegel
		tst	temp			; ...zu klein?
		brne	messwert_s		; nein...
		lds	temp,blinker		; Blinkzeit
		sbrc	temp,BIT3		; ...erreicht?
		rjmp	messwert_s		; nein...
		ldi	temp,86			; X-Position
		sts	dispx,temp
		ldi	temp,15			; Y-Position
		sts	dispy,temp
		ldi	counter,-1		; keine Begrenzung
		ldiw	Z,(2*LOWTXT)		; "LOW-INPUT"
		rcall	disp_printrom		; ...ausgeben
;
MESSWERT_S:	ldi	temp,94			; X-Position
		sts	dispx,temp
		ldi	temp,21			; Y-Position
		sts	dispy,temp
		ldi	counter,-1		; keine Begrenzung
		ldiw	Z,(2*SINADTXT)		; "SINAD"
		rcall	disp_printrom		; ...ausgeben
;
		rcall	disp_font2		; Normalfont einstellen
		ldi	temp,86			; X-Position
		sts	dispx,temp
		ldi	temp,30			; Y-Position
		sts	dispy,temp
;
		lds	temp,timer_lowinp	; Eingangspegel
		tst	temp			; ...zu klein?
		breq	messwert_over		; ja...
		lds	temp,(wertsinad+1)	; Maximum SINAD
		cpi	temp,48			; ...berschritten?
		brcs	messwert_tst		; nein...
		clr	temp			; Wert>47dB nicht
		sts	timer_disphold,temp	; ...anzeigen
MESSWERT_TST:	lds	temp,timer_disphold	; Eingangssignal
		tst	temp			; ...zu gro (Overflow)?
		brne	messwerte_out		; nein...
		ldi	counter,5		; mit Begrenzung:
MESSWERT_OVER:	ldiw	Z,(2*OVER)		; " ****"
		rcall	disp_printrom		; ...ausgeben
		rjmp	messwert_ende
;
MESSWERTE_OUT:	lds	akku0,(wertsinad+1)	; gleitenden Mittelwert
		rcall	disp_dez2r		; ...von SINAD ausgeben
		ldi	counter,2		; nur den Anfang:
		ldiw	Z,(2*DBVTXT)		; "dB"
		rcall	disp_printrom		; ...ausgeben
; ----------------------------------------------
MESSWERT_ENDE:	ret



; -----------------------------------------------------------------------------------------------
; Messwerte eintragen:							[  56,31 s,   1802 cyc]
; -----------------------------------------------------------------------------------------------

BARGRAF:	ldi	temp,0b11111111		; kein Muster
		sts	dispmuster,temp		; ...setzen
;
		ldi	temp,102		; Position des
		sts	dispx,temp		; ...kleinen
		ldi	temp,37			; ...Markierungs-
		sts	dispy,temp		; ...Dreiecks oben
		rcall	disp_font1		; kleinen Font
		ldi	temp,$90		; Dreieck nach unten
		rcall	disp_out		; ...ber dem Rahmen anzeigen
		ldi	temp,102		; Position des
		sts	dispx,temp		; ...kleinen
		ldi	temp,47			; ...Markierungs-
		sts	dispy,temp		; ...Dreiecks
		rcall	disp_font1		; kleinen Font
		ldi	temp,$8f		; Dreieck nach oben
		rcall	disp_out		; ...unter dem Rahmen anzeigen
;
		ldi	temp,91			; X-Position des
		sts	dispx,temp		; ...Streifens setzen
		ldi	temp,42			; Y-Position des
		sts	dispy,temp		; ...Streifens setzen
		ldi	temp,25			; Abmessungen
		sts	dispbreite,temp		; ...der ueren
		ldi	temp,5			; ...Umrahmung
		sts	disphoehe,temp		; ...setzen
		rcall	disp_rahmen		; Rahmen zeichnen
;
		lds	temp,timer_disphold	; Eingangssignal
		tst	temp			; ...zu gro (Overflow)?
		breq	bargraf_end		; ja...
		lds	temp,timer_lowinp	; Eingangspegel
		tst	temp			; ...zu klein?
		breq	bargraf_end		; ja...

; ----------------------------------------------
; SINAD-Wert als BAR in den Rahmnen zeichnen:

		ldi	temp,92			; X-Position des
		sts	dispx,temp		; ...Streifens setzen
		ldi	temp,42			; Y-Position des
		sts	dispy,temp		; ...Streifens setzen
		ldi	temp,5
		sts	disphoehe,temp
		lds	temp,(wertsinad+1)	; MW-SINAD-Messergebnis
		cpi	temp,25			; Anzeigemaximum berschritten?
		brcs	bargraf_out		; nein...
		ldi	temp,24			; Maximum setzen
BARGRAF_OUT:	sts	dispbreite,temp		; ...als Bar-Breite setzen
		ldi	temp,$ff		; Fllmuster setzen
		rcall	disp_rect		; ...und Bar erzeugen
; ----------------------------------------------
BARGRAF_END:	ret



; -----------------------------------------------------------------------------------------------
; Berechne SINAD-Verhltnis aus S^2 und (N+D)^2 in DISPBUF		[  31,84 s,   1019 cyc]
; -----------------------------------------------------------------------------------------------

SINAD:		ldiw	Z,DISPBUF		; normiertes Spektrum von 0..3937,5Hz (Index: 0..63)

; ----------------------------------------------
; 1kHz-Signal-Channel 16

		ldd	temp,Z+16		; lade 8Bit Signal-Channel
		mul	temp,temp		; ...und bilde Signal-Quadrat
		sts	wertqs,akku0		; 16Bit Signal-Quadrat
		sts	(wertqs+1),akku1	; ...retten
		cpi	temp,LOWSCHWELLE	; Testsignals <10 dB?
		brcs	sinad_noise		; nein...
		ldi	temp,DELAY1S		; Warnung in Routine "MESSWERT:"
		sts	timer_lowinp,temp	; ...blinkend anzeigen

; ----------------------------------------------
; Noise ohne Signal- und Schutz-Channel 15..17:

SINAD_NOISE:	adiw	Z,3			; Beginne bei Channel 3 = 185,5 Hz
		clr	const			; Null-Erweiterung
		clr	akku2			; Summierakku fr
		clr	akku3			; ...(N+D)^2 initialisieren
		clr	buffer			; Zhler fr frei gegebene Kanle
		ldi	counter,3		; erster Index in den Ausgabebuffer
;
SINAD_LOOP:	cpi	counter,15		; Index <15 (1kHz - Schutz-Channel)
		brcs	sinad_get		; ja...
		cpi	counter,18		; Index <18 (1kHz + Schutz-Channel)?
		brcs	sinad_next		; nein...
SINAD_GET:	inc	buffer			; Kanal zhlen
		ld	temp,Z			; hole Rauschanteil
		mul	temp,temp		; ...und bilde das Quadrat (=Leistung)
		add	akku2,akku0		; summiere
		adc	akku3,akku1		; ...das (N+D)^2
SINAD_NEXT:	adiw	Z,1			; nchste Adresse
		inc	counter			; nchster Index
		cpi	counter,64		; Ende erreicht?
		brne	sinad_loop		; nein...
;
		mov	akku0,akku2		; Lade 16Bit
		mov	akku1,akku3		; ...Summe (N+D)^2
		mov	temp,buffer		; korrigiere Anzahl wegen
		addi	temp,2			; ...der fehlenden Channels 15 und 17
		rcall	mul24			; ...und berechne (n+2) * Summe((N+D)^2)
		mov	akku6,buffer		; lade
		clr	akku7			; ...24Bit
		clr	akku8			; ...Divisor (n)
		rcall	div24			; ...und berechne ((n+2) * Summe((N+D)^2)) / n
		sts	wertqnd,akku0		; korrigierte 24Bit Rausch-
		sts	(wertqnd+1),akku1	; ...Quadrat-Summe retten

; ---------------------------------------------
; Berechne: 1 + ((256 * S^2) / (N+D)^2) / 256

		clr	akku0			; 256*
		lds	akku1,wertqs		; ...S^2
		lds	akku2,(wertqs+1)	; ...laden
		lds	akku6,wertqnd		; Summe (N+D)^2
		lds	akku7,(wertqnd+1)	; ...laden
		clr	akku8			; ...24Bit ergnzen
		ldi	temp,255		; dB-Maximum laden
		mov	buffer,akku6		; Division
		or	buffer,akku7		; ...durch 0?
		breq	sinad_pqdb		; ja, verwende DB-Maximum...
;
		rcall	div24			; Berechne 256 * (S^2)/(N+D)^2 in akku2..0
		inc	akku1			; S/N + 1, Overflow?
		brne	sinad_quotient		; nein...
		inc	akku2			; berlauf addieren

; Tabellensuche: Index=dB-Wert, Inhalt=Leistungsverhltnis

SINAD_QUOTIENT:	ldi	temp,-1			; Anfang bei Index -1
		ldiw	Z,(2*DB10TAB)		; Lookuptabelle fr Leistungsverhltnisse
SINAD_PQLOOP:	inc	temp			; nchsten dB-Wert einstellen
		cpi	temp,48			; Tabellenende erreicht?
		brcc	sinad_pqdb		; ja...
		lpm	akku3,Z+		; SINAD-Leistungsverhltnis (L)
		lpm	akku4,Z+		; SINAD-Leistungsverhltnis (H)
		cp	akku4,akku2		; Tabellenwert (H) < SINAD-Wert (H)?
		brlo	sinad_pqloop		; ja...
		cp	akku3,akku1		; Tabellenwert (L) < SINAD-Wert (L)
		brlo	sinad_pqloop		; ja...
SINAD_PQDB:	lds	buffer,timer_overflow	; Eingangssignal
		tst	buffer			; ...zu gro (Overflow)?
		brne	sinad_end		; ja, Ergebnis nicht mitteln...

; ----------------------------------------------
; gleitenden Mittelwert von SINAD bestimmen:

		rcall	mean_medium		; SINAD-Ergebnis in (temp) mitteln

; -------------
SINAD_END:	ret



; -----------------------------------------------------------------------------------------------
; Gleitenden Mittelwert aus 2 Samples berechnen:
; -----------------------------------------------------------------------------------------------

MEAN_FAST:	lds	akku0,(wertsinad+1)	; Mittelwert (8Bit) laden
		add	akku0,temp		; bestimme
		rol	akku0			; ...Mittelwert
		sts	(wertsinad+1),akku1	; neuen 8Bit-Mittelwert speichern
; -------------
		ret



; -----------------------------------------------------------------------------------------------
; Gleitenden Mittelwert aus 16 Samples berechnen:
; -----------------------------------------------------------------------------------------------

MEAN_MEDIUM:	clr	const			; 0-Ergnzung
		lds	akku0,wertsinad		; letzten
		lds	akku1,(wertsinad+1)	; ...Mittelwert (16Bit) laden
		mov	akku2,akku0		; Rechenbuffer
		mov	akku3,akku1		; ...laden
;
		lsr	akku3			; bestimme
		ror	akku2			; ...1/16
		lsr	akku3			; ...des
		ror	akku2			; ...gleitenden
		lsr	akku3			; ...Mittelwerts
		ror	akku2			; ...im
		lsr	akku3			; ...Rechen-
		ror	akku2			; ...buffer
;
		sub	akku0,akku2		; berechne 15/16 des
		sbc	akku1,akku3		; ...akkumulierten Mittelwerts
;
		clr	akku2			; 16Bit-Erweiterung des 8Bit-Ergebnisses
		mov	akku3,temp		; bereite 8Bit-Ergebnis zur Shift-Division vor
		lsr	akku3			; bestimme
		ror	akku2			; ...1/16
		lsr	akku3			; ...des
		ror	akku2			; ...8Bit-
		lsr	akku3			; ...Ergebnisses
		ror	akku2			; ...im
		lsr	akku3			; ...Rechen-
		ror	akku2			; ...buffer
;
		add	akku0,akku2		; berechne 16/16 des
		adc	akku1,akku3		; ...neuen gleitenden Mittelwerts
;
		sts	wertsinad,akku0		; neuen gleitende
		sts	(wertsinad+1),akku1	; ...16Bit-Mittelwert speichern
; -------------
		ret



; -----------------------------------------------------------------------------------------------
; Gleitenden Mittelwert aus 256 Samples berechnen:
; -----------------------------------------------------------------------------------------------

MEAN_SLOW:	clr	const			; 0-Ergnzung
		lds	akku0,wertsinad		; letzten
		lds	akku1,(wertsinad+1)	; ...Mittelwert (16Bit) laden
		mov	akku2,akku1		; 1/256 des Mittelwerts
		sub	akku0,akku2		; ergibt: 255/256 des
		sbc	akku1,const		; ...gleitenden Mittelwerts
		add	akku0,temp		; neuen Messwert
		adc	akku1,const		; ...mit bertrag addieren
		sts	wertsinad,akku0		; das ist der neue
		sts	(wertsinad+1),akku1	; ...gleitende Mittelwert (16Bit)
; -------------
		ret



; -----------------------------------------------------------------------------------------------
; Setze Bereiche auerhalb der Filterindizes auf 0:			[  24,53 s,    785 cyc]
; -----------------------------------------------------------------------------------------------

FILTER:		lds	akku0,indexstart	; erster durchgelassener Filter-Channel
		lds	akku1,indexend		; letzter durchgelassener Filter-Channel
		ldiw	Z,DISPBUF		; Zeiger auf normiertes Spektrum von 0..3937,5Hz (Index: 0..63)
		clr	counter			; Beginne beim Gleichanteil
		clr	const			; 0-Erweiterung
;
FILTER_LOOP:	cp	counter,akku0		; Index > untere Grenze?
		brcs	filter_clr		; nein...
		cp	counter,akku1		; Index > obere Grenze?
		brls	filter_next		; nein...
FILTER_CLR:	st	Z,const			; Lsche Indexelement (Filterfunktion)
FILTER_NEXT:	adiw	Z,1			; nchstes Element adressieren
		inc	counter			; Bufferende
		cpi	counter,64		; ...berschritten?
		brne	filter_loop		; nein...
; -------------
		ret



; -----------------------------------------------------------------------------------------------
; Skaliere 16Bit (0..$6163) --> 8Bit (0..$fe) ohne Gleichanteil!
; -----------------------------------------------------------------------------------------------

SKALIERE:	clr	const			; NULL-Wert
		ldiw	Y,(DISPBUF)		; 8Bit Ergebnisbuffer linear (0..$ff)
		st	Y+,const		; Setze Gleichanteil auf 0
		ldi	counter,(FFT_N/2)-1	; Nullwert nicht bercksichtigen
		ldiw	X,(POWERBUF+2)		; 16-Bit Powerbuffer (0..$6163)
;
		ldi	buffer,$fe		; Maximum laden
SKALLOOP:	ld	akku2,X+		; 16Bit Ergebnis
		ld	akku3,X+		; ...laden
		lsl	akku2
		rol	akku3
		brcs	skalmax			; berlauf...
		cp	akku3,buffer		; Maximum erreicht?
		brcc	skalmax			; ja...
SKALSTO:	st	Y+,akku3
		rjmp	skalnext
;
SKALMAX:	st	Y+,buffer		; Begrenzung speichern
		ldi	temp,DELAY100MS		; setze Haltezeit
		sts	timer_overflow,temp	; ...fr ERROR-LED
SKALNEXT:	dec	counter			; ferig?
		brne	skalloop		; nein...

; Overflowtest:

		lds	temp,timer_overflow	; Overflow
		tst	temp			; ...aufgetreten?
		brne	skaliere_end		; ja...
		ldi	temp,DELAY1S		; Ohne Overflow: Haltezeit
		sts	timer_disphold,temp	; ...stndig neu setzen
; -------------
SKALIERE_END:	ret



; -----------------------------------------------------------------------------------------------
; Gepunkteten Rahmen zeichnen:
; -----------------------------------------------------------------------------------------------

RAHMEN:		ldi	temp,8			; x-start
		sts	dispx,temp		; ...setzen
		ldi	temp,16			; y-start
		sts	dispy,temp		; ...setzen
		ldi	temp,112		; Gre
		sts	dispbreite,temp		; ...des
		ldi	temp,32			; ...Rahmens
		sts	disphoehe,temp		; ...einstellen
		ldi	temp,0b10101010		; Randmuster
		sts	dispmuster,temp		; ...setzen
		call	disp_rahmen		; Rahmen zeichnen
;
		ldi	temp,$ff		; volle Linie
		sts	dispmuster,temp		; ...setzen
; --------------
		ret



; -----------------------------------------------------------------------------------------------
; Werte Drehgebereingaben aus:
; -----------------------------------------------------------------------------------------------

DG_MANAGER:	rcall	dg_taste		; Tasteneingaben erkennen
		sbis	flags2,TASTEKURZ	; kurzer Tastendruck?
		rjmp	dg_dreh			; nein...
		lds	temp,state		; schon in der
		cpi	temp,3			; ...Menauswahl?
		breq	dg_dreh			; ja, nchste Eingabe hier nicht lschen...
		ldi	temp,3			; Menauswahl
		sts	state,temp		; ...aufrufen
		cbi	flags2,TASTEKURZ	; Eingabe ist abgearbeitet

; ----------------------------------------------
; Drehgeberposition auswerten

DG_DREH:	ldiw	Z,(2*DGJUMP)		; Tabelle aller DG-Einstellungen
		lds	temp,dgstate		; DG-Typ laden
		rcall	select			; ...und einstellbar machen
		lds	temp,dgstate		; zum Erkennen von Auswahl-nderungen
		sts	dgstatelast,temp	; ...den letzten Aufruf merken
; -------------
		ret


; ---------------------------------------------
; Sprungtabelle aller DG-Einstellungen:

DGJUMP:		.dw	P0			; 0: Verstrkung
		.dw	P1			; 1: Menauswahl


; ---------------------------------------------
; Verstrkung einstellen:
; ---------------------------------------------

P0:		lds	buffer,dgstatelast	; erster Aufruf nach
		tst	buffer			; ...einer neuen P0-Auswahl?
		breq	p0_run			; nein...
		lds	temp,vein		; beim ersten Aufruf: absolute
		rcall	dg_set			; ...Drehgeber-Position einstellen
		rjmp	p0_end
;
P0_RUN:		rcall	dg_get			; hole aktuelle DG-Position
		lds	buffer,vein		; nderung
		cp	buffer,temp		; ...aufgetreten?
		breq	p0_end			; nein...
P0_SET:		sts	vein,temp		; speichere neuen Verstrkungswert
		ldi	buffer,255		; rechts Drehen muss
		sub	buffer,temp		; ...den Widerstand A-W
		mov	temp,buffer		; ...erhhen (
		rcall	v_set			; setze die Verstrkung
; -------------
P0_END:		ret

; ---------------------------------------------
; Menauswahl einstellen:
; ---------------------------------------------

P1:		lds	buffer,dgstatelast	; erster Aufruf nach
		cpi	buffer,1		; ...einer neuen P1-Auswahl?
		breq	p1_run			; nein...
		lds	temp,bbsel		; beim ersten Aufruf: absolute
		rcall	dg_set			; ...Drehgeber-Position einstellen
		rjmp	p1_end
;
P1_RUN:		rcall	dg_get			; hole aktuelle DG-Position
		cpi	temp,3			; Maximum berschritten?
		brcs	p1_bbsel		; nein...
		ldi	temp,2			; Maximum
		rcall	dg_set			; ...setzen
P1_BBSEL:	sts	bbsel,temp		; neuen Wert retten
; -------------
P1_END:		ret



; -----------------------------------------------------------------------------------------------
; Hole DG-nderung nach (temp) und Z-Bit:
; -----------------------------------------------------------------------------------------------

DG_RELATIV:	push	buffer
; -------------
		lds	buffer,dgpos		; alte Position
		lds	temp,TCD1_CNT		; neue Position
		sts	dgpos,temp		; ...retten
		sub	temp,buffer		; Differenz zum letzten Aufruf
; -------------
		pop	buffer
		ret



; -----------------------------------------------------------------------------------------------
; Stelle Drehgeberwert aus (temp) ein:
; -----------------------------------------------------------------------------------------------

DG_SET:		push	ZL
		push	ZH
; --------------
		sts	dgpos,temp		; Position retten
		mov	ZL,temp			; Vorgabewert
		clr	ZH			; ...laden
		lsl	ZL			; Wert in Position
		rol	ZH			; ...bringen
		stsw	TCD1_CNT,Z		; Timer-Register einstellen
; --------------
		pop	ZH
		pop	ZL
		ret



; -----------------------------------------------------------------------------------------------
; Hole DG-Wert nach (temp), begrenze auf 0..255:
; -----------------------------------------------------------------------------------------------

DG_GET:		push	ZL
		push	ZH
; --------------
		ldsw	Z,TCD1_CNT		; hole aktuelle Einstellung
DG_TEST1:	tst	ZH			; underflow?
		brpl	dg_test2		; nein...
		clr	ZL			; Minimum
		clr	ZH			; ...laden
		rjmp	dg_update
;
DG_TEST2:	cpiw	Z,(255)<<1		; Maximum erreicht?
		brlo	dg_getok		; nein...
DG_MAX:		ldiw	Z,(255)<<1		; Maximum laden
DG_UPDATE:	stsw	TCD1_CNT,Z		; korrigierten Wert im Timer speichern
DG_GETOK:	ror	ZH			; erzeuge
		ror	ZL			; ...den
		mov	temp,ZL			; ...DG-Wert
		sts	dgpos,temp		; Position retten
; --------------
		pop	ZH
		pop	ZL
		ret



; -----------------------------------------------------------------------------------------------
; Werte Tasteneingaben des Drehgebers in TASTEKURZ und TASTELANG aus:
; -----------------------------------------------------------------------------------------------

DG_TASTE:	sbic	VPORT3_IN,DG_E		; DG-Taste jetzt gedrckt?
		rjmp	dg_tasteausw		; nein...
		sbic	flags2,TASTEENTPRELLT	; Taste bereits entprellt?
		rjmp	dg_tastewaitl		; ja...
		sbic	flags2,TASTEDRUCK	; Taste zuvor gedrckt?
		rjmp	dg_tastewaitk		; ja...
		sbi	flags2,TASTEDRUCK	; Taste als gedrckt markieren
		ldi	temp,DELAY100MS		; und Entprellzeit
		sts	timer_dgkurz,temp	; ...starten
		rjmp	dg_tasteend

; Tastendruck H->L Entprellen:

DG_TASTEWAITK:	lds	temp,timer_dgkurz	; Entprellzeit
		tst	temp			; ...abgelaufen?
		brne	dg_tasteend		; nein...
		sbi	flags2,TASTEENTPRELLT	; --> Tastendruck ist entprellt
		ldi	temp,DELAY500MS		; Dauerdruckzeit
		sts	timer_dglang,temp	; ...starten	
		rjmp	dg_tasteend

; Langen Tastendruck auswerten:

DG_TASTEWAITL:	lds	temp,timer_poweroff	; Ausschaltzeit
		tst	temp			; ...abgelaufen?
		brne	dg_tastelang		; nein...
		cbi	VPORT0_OUT,POWERONHOLD	; --> PowerOn nicht mehr halten (Ausschalten)
		ldi	temp,1			; Ausschaltbildschirm
		sts	state,temp		; ...aufrufen
DG_TASTELANG:	lds	temp,timer_dglang	; Langzeitdruck
		tst	temp			; ...abgelaufen?
		brne	dg_tasteend		; nein...
		sbi	flags2,TASTEWAIT	; Langzeitauswertung abgeschlossen
		rjmp	dg_tasteend
;
; Taste ist nicht gedrckt:
;
DG_TASTEAUSW:	ldi	temp,DLY3S		; Ausschaltzeit
		sts	timer_poweroff,temp	; ...stndig starten
		sbis	flags2,TASTEENTPRELLT	; Taste entprellt?
		rjmp	dg_tasteend		; nein...
		sbic	flags2,TASTEWAIT	; Langzeitauswertung abgeschlossen?
		rjmp	dg_tastel		; ja...
		sbi	flags2,TASTEKURZ	; --> kurzen Tastendruck markieren
		cbi	flags2,TASTELANG	; kurzen Tastendruck lschen
		rjmp	dg_tasteinit
;
DG_TASTEL:	sbi	flags2,TASTELANG	; --> langen Tastendruck markieren
		cbi	flags2,TASTEKURZ	; kurzen Tastendruck lschen

; Tasteneingabe in den Ruhezustand setzen:

DG_TASTEINIT:	cbi	flags2,TASTEENTPRELLT	; Taste als nicht entprellt markieren
		cbi	flags2,TASTEDRUCK	; Taste als losgelassen markieren
		cbi	flags2,TASTEWAIT	; Langzeitauswertung in Ruhezustand
		clr	temp			; ...und Langzeittimer
		sts	timer_dglang,temp	; ...lschen
; -------------
DG_TASTEEND:	ret



; -----------------------------------------------------------------------------------------------
; Aliasing-Filter aus (temp) einstellen:
; -----------------------------------------------------------------------------------------------

SET_FILTER:	ldiw	Z,(2*BANDBREITE)	; zeige auf Auswahltabelle
		ldi	buffer,26		; Lnge jedes Eintrags
		mul	temp,buffer		; berechne Offset
		add	ZL,akku0		; adressiere die
		adc	ZH,akku1		; ...ausgewhle Filterfunktion
;
		lpm	temp,Z+			; lade
		sts	indexstart,temp		; ...Anfangs-Index der FFT
		lpm	temp,Z+			; lade
		sts	indexend,temp		; ...End-Index der FFT
		lpm	YL,Z+			; hole Timerkonstante
		lpm	YH,Z+			; ...fr die MAX7407
		stsw	filtertxtp,Z		; Rette Anfang der zugehrigen Textausgabe
		movw	Z,Y			; Stelle Timer E fr den
		rcall	set_timer_e0		; ...externen Takt des MAX7407 ein
; -------------
		ret



; -----------------------------------------------------------------------------------------------
; Verstrkung des Vorverstrkers mit Wert in (temp) einstellen:
; -----------------------------------------------------------------------------------------------

V_SET:		push	counter
		push	buffer
; ----------------------------------------------
; A1 und A0 vorbereiten:

		clr	buffer			; Bit1..0 = A1..0
		ldi	counter,6		; ins
V_SETLOOP1:	lsl	temp			; ...MSB
		rol	buffer			; ...schieben
		dec	counter			; fertig?
		brne	v_setloop1		; nein...
;
		cbi	VPORT2_OUT,EPOT_NCS	; Baustein selektieren
		ldi	counter,10		; 10 Bits ausgeben
V_SETLOOP2:	cbi	VPORT2_OUT,EPOT_CLK	; Grundzustand L einstellen
		lsl	temp			; Daten und Adressbits nach
		rol	buffer			; ...CY schieben, jetzt 1?
		brcs	v_set1			; ja...
V_SET0:		cbi	VPORT2_OUT,EPOT_SDI	; --> 0 ausgeben
		rjmp	v_settakt
;
V_SET1:		sbi	VPORT2_OUT,EPOT_SDI	; --> 1 ausgeben
		nop				; Zeitausgleich
V_SETTAKT:	sbi	VPORT2_OUT,EPOT_CLK	; L->H Flanke ausgeben
		dec	counter			; alle Bits ausgegeben?
		brne	v_setloop2		; nein...
;
		nop
		cbi	VPORT2_OUT,EPOT_CLK	; Grundzustand L einstellen
		nop
		sbi	VPORT2_OUT,EPOT_NCS	; Daten bernehmen, Baustein deselektieren
; -------------
		pop	buffer
		pop	counter
		ret



; -----------------------------------------------------------------------------------------------
; Error-LED kurz blinken lassen:
; -----------------------------------------------------------------------------------------------

ERRORLED:	lds	temp,timer_overflow	; luft der
		tst	temp			; ...Error-Timer?
		brne	errorledein		; ja...
		cbi	VPORT2_OUT,OVERFLOW	; LED aus
		ret
; -------------
ERRORLEDEIN:	sbi	VPORT2_OUT,OVERFLOW	; LED ein
; -------------
		ret



; -----------------------------------------------------------------------------------------------
; Programm der Nummer in (temp) aus Tabelle in Z anspringen:
; -----------------------------------------------------------------------------------------------

SELECT:		clr	const			; 16Bit-Erweiterung
		lsl	temp			; 2 Bytes/Tabelleneintrag
		add	ZL,temp			; zeige auf den
		adc	ZH,const		; ...aufzurufenden Eintrag
		lpm	YL,Z+			; lade den
		lpm	YH,Z			; ...Einsprungpunkt
		movw	Z,Y			; Sprungadresse laden
		ijmp				; ...und anspringen



; -----------------------------------------------------------------------------------------------
; Timer mit Wert in (ZH:ZL) einstellen
; -----------------------------------------------------------------------------------------------

SET_TIMER_E0:	stsw	TCE0_PERBUF,Z		;; Periode einstellen
		lsr	ZH			;; halbe Periode 
		ror	ZL			;; ...mit COMPARE-D fr 
		stsw	TCE0_CCDBUF,Z		;; ...ADC_CH0 (Event Channel 7) einstellen
; -------------
		ret



; -----------------------------------------------------------------------------------------------
; Timer im 10ms-Rythnus zhlen:							[2,00 s, 64 cyc]
; -----------------------------------------------------------------------------------------------

TIMER10:	decram	timer_100ms		; 100ms abgelaufen?
		brne	tim10			; nein...
		ldi	temp,10			; 100ms-Intervall neu laden
		sts	timer_100ms,temp	; ...und speichern
		rcall	timer100		; alle 100ms-Timer bearbeiten
;
TIM10:		decram	timer_overflow		; Haltetimer fr LED bei Overflow
		decram	timer_lowinp		; Haltezeit fr Low-Pegelwarnung
		decram	timer_disphold		; Haltezeit fr Displayanzeige nach Overflow
		decram	timer_dgkurz		; Entprellen des Tasters
		decram	timer_dglang		; Auswertung des langen Tastendrucks
		decram	timer_1000ms		; 1s abgelaufen
		brne	timer10_end		; nein...
		ldi	temp,100		; 1000ms-Intervall neu laden
		sts	timer_1000ms,temp	; ...und speichern
		rcall	timer1000		; alle 1s-Timer bearbeiten
; -------------
TIMER10_END:	ret



; -----------------------------------------------------------------------------------------------
; Timer im 100ms-Rythnus zhlen:					
; -----------------------------------------------------------------------------------------------

TIMER100:	sbi	flags1,TIM100MS		; 100ms sind vorbei
		lds	temp,blinker		; durchlaufender
		inc	temp			; ...Zhler fr
		sts	blinker,temp		; ...Blinkanzeigen
; -------------
		decram	timer_poweroff		; ganz langer Tastendruck fr PowerOff
		decram	timer_wait		; Wartezeit
; -------------
		ret



; -----------------------------------------------------------------------------------------------
; Timer im 1s-Rythnus zhlen:					
; -----------------------------------------------------------------------------------------------

TIMER1000:	sbi	flags1,TIM1000MS	; 1s ist vorbei
		ret



; -----------------------------------------------------------------------------------------------
; Warte exklusiv <counter>*10ms mit Timerhilfe:
; -----------------------------------------------------------------------------------------------

WAITEXKLUSIV:	cbi	flags1,TIM10MS
WELOOP:		sbis	flags1,TIM10MS
		rjmp	weloop
		wdr				; Watchdog-Timer lschen
		dec	counter
		brne	waitexklusiv
		ret



; -----------------------------------------------------------------------------------------------
; Warte exklusiv im s-Bereich durch Zhlen:
; -----------------------------------------------------------------------------------------------

DLY2S:		rcall	dly1s
DLY1S:		rcall	dly500ms
DLY500MS:	push	counter
		ldi	counter,5		; --> ergibt 500ms
DLYLOOP3:	rcall	dly100ms		; Dauer: 100ms @ 32MHz
		dec	counter			; Zeit verbrauchen...
		brne	dlyloop3
		pop	counter
; -------------
		ret



; -----------------------------------------------------------------------------------------------
; Warte exklusiv im 100ms-Bereich durch Zhlen:
; -----------------------------------------------------------------------------------------------

DLY100MS:	push	counter
		ldi	counter,199		; --> ergibt 100ms
DLYLOOP2:	rcall	dly500us		; Dauer: 500us @ 32MHz
		dec	counter			; Zeit verbrauchen...
		brne	dlyloop2
; -------------
		pop	counter
		ret



; -----------------------------------------------------------------------------------------------
; Warte exklusiv im 100us-Bereich durch Zhlen:
; -----------------------------------------------------------------------------------------------

DLY500US:	rcall	dly100us
DLY400US:	rcall	dly100us
DLY300US:	rcall	dly100us
DLY200US:	rcall	dly100us
DLY100US:	push	counter
		ldi	counter,107		; --> ergibt 100us
DLYLOOP1:	rcall	dly1us			; Dauer: 1us @ 32MHz
		dec	counter			; Zeit verbrauchen...
		brne	dlyloop1
		pop	counter
; -------------
		ret



; -----------------------------------------------------------------------------------------------
; Warte exklusiv im 1us-Bereich durch Zhlen:
; -----------------------------------------------------------------------------------------------

DLY2US:		rcall	dly1us
DLY1US:		call	dly500ns		; (3) Dauer: 15 x 31,25ns = 500ns @ 32MHz
DLY500NS:	nop				; (1)
		nop				; (1)
		nop				; (1)
		nop				; (1)
		nop				; (1)
		nop				; (1)
		nop				; (1)
; -------------
		ret				; (5)



; -----------------------------------------------------------------------------------------------
; 16Bitx8Bit Multiplikation: (akku2..0) = (akku1..0) * (temp)		ca: [0,91 s, 29 cyc]
; -----------------------------------------------------------------------------------------------

MUL24:		push	counter
		push	const
; -------------
		push	akku1			; MS-Byte retten
		mul	akku0,temp		; Multiplikand (L) * (temp)
		mov	const,akku0		; Produkt Byte 1 retten
		mov	counter,akku1		; bertrag 1 retten
;
		pop	akku0			; Multiplikand (H)
		mul	akku0,temp		;    * (temp)
		mov	akku2,akku1		; Teilprodukt Byte 3
		add	counter,akku0		; Teilprodukt (H) zum bertrag 1 addieren
		mov	akku1,counter		; --> Produkt Byte 2
		clr	counter			; 0-Ergnzung
		adc	akku2,counter		; --> Produkt Byte 3
		mov	akku0,const		; --> Produkt Byte 1
; -------------
		pop	const
		pop	counter
		ret



; -----------------------------------------------------------------------------------------------
; Division: (akku1..0) Rest (rest) = (akku1..0) : (const) fr (const) < $80
; -----------------------------------------------------------------------------------------------

DIV16:		push	akku2
		push	akku3
		push	counter			; Zhler frei machen
; -------------
		ldi	counter,16		; 16 bit Division
		clr	rest			; Rest lschen
		clr	akku2			; 16Bit Erweiterung
		clr	akku3			; 0-Wert fr 16Bit Subtraktion erzeugen
DIV16_LOOP:	lsl	akku0
		rol	akku1
		rol	rest			; 16Bit
		rol	akku2			; ...Zwischenergebnis
		cp	rest,const		; 8Bit Divisor
		cpc	akku2,akku3		; ...enthalten?
		brcs	div16_next		; nein...
		sub	rest,const		; Divisor vom Rest
		sbc	akku2,akku3		; ...abziehen
		inc	akku0			; Ergebnisbit setzen
DIV16_NEXT:	dec	counter			; alle 16 Bit bearbeitet?
		brne	div16_loop		; nein...
; -------------
		pop	counter			; User-Zhler zurck laden
		pop	akku3
		pop	akku2
		ret



; -----------------------------------------------------------------------------------------------
; Division: (akku2..0) Rest (akku5..3) = (akku2..0) : (akku8..6)	ca: [11,31 s, 362 cyc]
; -----------------------------------------------------------------------------------------------

DIV24:		push	counter			; Zhler frei machen
; -------------
		ldi	counter,24		; 24 bit Division
		clr	akku3			; 24Bit
		clr	akku4			; ...Rest
		clr	akku5			; ...lschen
DIV24_LOOP:	lsl	akku0			; 24Bit
		rol	akku1			; ...Dividend
		rol	akku2			; ...in den
		rol	akku3			; 24Bit
		rol	akku4			; ...Rest
		rol	akku5			; ...schieben
		cp	akku3,akku6		; Divisor
		cpc	akku4,akku7		; ...im Rest
		cpc	akku5,akku8		; ...enthalten?
		brcs	div24_next		; nein...
		sub	akku3,akku6		; Divisor
		sbc	akku4,akku7		; ...vom Rest
		sbc	akku5,akku8		; ...abziehen
		inc	akku0			; ...und Ergebnisbit setzen
DIV24_NEXT:	dec	counter			; alle 24 Bit bearbeitet?
		brne	div24_loop		; nein...
; -------------
		pop	counter			; User-Zhler zurck laden
		ret



; -----------------------------------------------------------------------------------------------
; Test-Pin "H" setzen:								[0,28 s, 9 cyc]
; -----------------------------------------------------------------------------------------------

TEST_SET:	sbi	VPORT0_OUT,TEST
; --------------
		ret



; -----------------------------------------------------------------------------------------------
; Test-Pin "L" setzen:								[0,28 s, 9 cyc]
; -----------------------------------------------------------------------------------------------

TEST_CLR:	cbi	VPORT0_OUT,TEST
; --------------
		ret



; -----------------------------------------------------------------------------------------------
; Test-Pin ndern:								[0,34 s, 11 cyc]
; -----------------------------------------------------------------------------------------------

TEST_TOGGLE:	ldi	temp,(1<<TEST)
		sts	PORTA_OUTTGL,temp
; --------------
		ret



; -----------------------------------------------------------------------------------------------
; TEST_OUT ohne Interrupt-Unterbrechung --> ruhigeres Oszillogrammbild
; -----------------------------------------------------------------------------------------------

TEST_OUTEX:	pushsr
		cli				;;	Exklusiv
		rcall	test_out		;;
		popsr				;;	Ende
; -------------
		ret



; -----------------------------------------------------------------------------------------------
; *** DEBUG-Funktion *** Byte in <temp> an PA2 (Pin1) seriell ausgeben		[3,34 s, 107 cyc]
; -----------------------------------------------------------------------------------------------

TEST_OUT:	push	temp
		push	counter
; -------------
		ldi	counter,8		; Bitzhler
PA2SHIFT:	rol	temp
		brcc	pa2aus
		nop				; Ausgleich fr brcc
		sbi	VPORT0_OUT,TEST		; Start einer
		cbi	VPORT0_OUT,TEST		; ...Bitzelle markieren
		sbi	VPORT0_OUT,TEST		; (2) Bitstart
		rjmp	pa2end			; (2) 1 ausgeben

PA2AUS:		sbi	VPORT0_OUT,TEST		; (2) Bitstart
		cbi	VPORT0_OUT,TEST		; (2) 0 ausgeben
		nop
		nop
		nop
PA2END:		dec	counter			; alle Bits ausgegeben?
		brne	pa2shift		; nein...
		nop
		nop
		nop
		nop
		cbi	VPORT0_OUT,TEST		; Ruhezustand setzen
		sbi	VPORT0_OUT,TEST		; Ende der letzten
		cbi	VPORT0_OUT,TEST		; ...Bitzelle markieren
; -------------
		pop	counter
		pop	temp
		ret



; ********************************************************************************************
; ********************************************************************************************
;
;	Alle Routinen ab hier (c) ChaN, 2004; http://elm-chan.org/
;	nderungen sind im Kommentar mit "DC7GB:" gekennzeichnet.
;
; ********************************************************************************************
; ********************************************************************************************


; --------------------------------------------------------------------------------------------
; Erzeuge signed Eingabe (X) und skaliere mit Window (Z) in 32Bit Arbeitsbuffer (Y) = {Re},{Im}
; --------------------------------------------------------------------------------------------

do_window:	ldiw	X,CAPTBUF0			; DC7GB:	CAPTBUF0 vorladen
		sbic	flags1,CAPTBUFWR		; DC7GB:	nutzt DAC CAPTBUF1?
		rjmp	loadbufy			; DC7GB:	ja...
;
		ldiw	X,CAPTBUF1			; DC7GB:	CAPTBUF1 verwenden
LOADBUFY:	ldiw	Y,BflyBuf			; DC7GB:	Destination
		ldiw	Z,(2*t_hamming128)		; Window table
;
		ldi	CL,FFT_N
		clr	r15				; Null-Wert definieren
ms_l1:		lpmw	A,Z+				; Get a window attenuation ratio
		ldw	B,X+				; Get an input value
		subiw	B,512				; unsigned -> signed
		FMULS16	A,B,T4,T2			; Apply window
		stw	Y+,T4				; Store real
		st	Y+,r15				; Clear image
		st	Y+,r15				; /
		dec	CL
		brne	ms_l1
; -------------
		ret



; --------------------------------------------------------------------------------------------
; Execute butterfly operations (not optimized)
; --------------------------------------------------------------------------------------------

do_fft:		ldi	XH, 1			; u
		ldi	EL, FFT_N/2		; l
df_l1:		ldiw	Z, BflyBuf		; Z = BflyBuf
		ldiw	Y, BflyBuf		; Y = BflyBuf + l * 4
		muli	EL, 4			;
		addw	Y, T0			; /
		mul	AL, XH			; T10L = u * 4
		mov	T10L, T0L		; /
		mov	XL, XH			; w = u
df_l2:		clr	T14L			; p=0
df_l3:		lddw	A, Z+0			; A = [Z+0] - [Y+0], [Z+0] += [Y+0]
		movw	CL, AL			; B = [Z+2] - [Y+2], [Z+2] += [Y+2]
		lddw	D, Y+0			;
		subw	A, D			;
		addw	C, D			;
		stw	Z+, C			;
		lddw	B, Z+0			;
		movw	CL, BL			;
		lddw	D, Y+2			;
		subw	B, D			;
		addw	C, D			;
		stw	Z+, C			; /
		movw	T0L, ZL
		movw	ZL, T14L		; C=cos(p), D=sin(p)
		addiw	Z, t_cos_sin128*2	;
		lpmw	C, Z+			;
		lpmw	D, Z+			; /
		movw	ZL, T0L
		FMULS16	A, C, T4, T2		; [Y+0] = A * C + B * D
		FMULS16	B, D, T8, T6		; [Y+2] = B * C - A * D
		addw	T2, T6			;
		adcw	T4, T8			;
		stw	Y+, T4			;
		FMULS16	B, C, T4, T2		;
		FMULS16	A, D, T8, T6		;
		subw	T2, T6			;
		sbcw	T4, T8			;
		stw	Y+, T4			; /
		add	T14L, T10L		; p += u
		rjne	df_l3
		muli	EL, 4			; Y += l * 4, Z += l * 4; (skip split segment)
		addw	Y, T0			;
		addw	Z, T0			; /
		dec	XL			; --w
		rjne	df_l2
		lsl	XH			; u *= 2
		lsr	EL			; l /= 2
		rjne	df_l1
; -------------
		ret


; --------------------------------------------------------------------------------------------
; Get scalar spectrum:
; --------------------------------------------------------------------------------------------

do_power:	ldiw	Z, (2*t_desc128)	; Descramble table
		ldiw	Y, POWERBUF		; DC7GB:	FFT-Betragsbuffer (0..$6163) Big-Endian!
		ldi	CH, FFT_N/2		; Number of elements
; -------------
ub_l1:		lpmw	A, Z+			; Get a vector value (A = r, B = i)
		ldiw	X, BflyBuf		;
		addw	X, A			;
		ldw	A, X+			;
		ldw	B, X+			; /
		FMULS16	A, A, T4, T2		; T4:T2 = A*A
		FMULS16	B, B, T8, T6		; T8:T6 = B*B
		addw	T2, T6			; Bilde die 32Bit
		adcw	T4, T8			; ...Summe in T4:T2
		SQRT32				; A = sqrt(A * A + B * B); 0..32767 (scalar)
.ifdef	_ORIGINAL
		movw	T2L, AL			; AL = sqrt(A); 0..181 (root compression)
		ldi	AH, 100			; T0H = AL/3; (scaling)	(Orginal: 256/3)
		mul	AL, AH			; /
		st	Y+, T0H			; speichere Betragswert
.else
		st	Y+,AL			; DC7GB:	Speichere 16Bit-Ergebnis 
		st	Y+,AH			; DC7GB:	...im Big-Endian-Format!
.endif
;
		dec	CH			; Buffer fertig bearbeitet?
		rjne	ub_l1			; nein...
; -------------
		ret
